//#define DEBUG
//#define ACTION
#include <stdio.h>

#define CRLF "<BR>\n"
#include <bnMakro.h>
#include "bnSQL.h"

#include "DEFExcelPerl.h"

#include <EXTERN.h>
#include <perl.h>

//#define FIRST_LINE_FIELD_NAME

//#define CMD_STD_OUT(sOut) { fprintf( stderr, "pcmd:%s<br>\n", sOut); }
#define CMD_STD_OUT(sOut) {}

char	plCMD[1024];


extern "C" {

_bnColumn		*coInsertX		( _bnTable *tb, _DEF2COL *DEF2Global, char *Name, long Type, long Size, long Flags );


static void xs_init (pTHX);
EXTERN_C void boot_DynaLoader (pTHX_ CV* cv);
EXTERN_C void xs_init(pTHX) {
char *file = (char *)__FILE__;
// DynaLoader is a special case 
    newXS((char *)"DynaLoader::boot_DynaLoader", boot_DynaLoader, file);
}//	EXTERN_C void xs_init(pTHX)


char 	*dbOpen ( _bnDataBase *db ) {
PFLID

char *Error = db->Error;

//error check
    if ( ! db		) return NULL;

    if ( Error[0] 	) return Error;
    if ( db->Conn	) return Error;	//already open

#ifdef ACTION
    printf ( "%s"	, (char *)__PRETTY_FUNCTION__ );
    printf ( "	%s"	, (char *)__FILE__ );
    printf ( "	%s"	, db->Base );
    printf ( "@%s"	, db->Host );
    printf ( "\n" );
#endif

PerlInterpreter	*my_perl;

char *embedding[] = { (char *)"", (char *)"-e", (char *)"0" };
//char *embedding[] = { (char *)"" };
int argc = 0;
char **argv = NULL;
char **env = NULL;
    //PERL_SYS_INIT3(&argc,&argv,&env);

    PERL_SYS_INIT3(NULL,NULL,NULL);

    my_perl = perl_alloc();

    perl_construct( my_perl );

    perl_parse(my_perl, xs_init, 3, embedding, NULL);

    PL_exit_flags |= PERL_EXIT_DESTRUCT_END;
    perl_run(my_perl);

    sprintf ( plCMD, "\
use encoding 'iso-8859-1';\
use DBI;\
    $hDb = DBI->connect( \"DBI:Excel:file=%s/%s\", undef, undef );\
", db->Host, db->Base );

    eval_pv ( plCMD, FALSE );//2do catch error
    CMD_STD_OUT ( plCMD );

    db->Conn = (PerlInterpreter*)my_perl;

    return Error;

}//char 	*dbOpen ( _bnDataBase *db )


char	*dbClose ( _bnDataBase *db ) {
PFLID

//error check
    if ( ! db		) return NULL;

char *Error = db->Error;

    if ( ! db->Conn	) return Error;	//already closed

#ifdef ACTION
    printf ( "%s"	, (char *)__PRETTY_FUNCTION__ );
    printf ( "	%s"	, (char *)__FILE__ );
    printf ( "	%s"	, db->Base );
    printf ( "@%s"	, db->Host );
    printf ( "\n" );
#endif

PerlInterpreter *my_perl = (PerlInterpreter *)db->Conn;
    perl_destruct	( my_perl );
    perl_free		( my_perl );
    PERL_SYS_TERM	();

    db->Conn = NULL;

    return Error;

}//char	*dbClose ( _bnDataBase *db )


char	*tbOpen		( _bnTable *tb ) {
PFLID

//error check
    if ( ! tb		) return NULL;

char *Error = tb->Error;

    if ( Error[0] 	) return Error;
    if ( tb->Result	) return Error;	//alreay open
    if ( ! tb->db	) SER ( "! tb->db"		);
    if ( ! tb->db->Conn	) SER ( "! tb->db->Conn"	);
//strcpy ( tb->Name, "Sheet1" );
#ifdef ACTION
    printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
    printf ( "		%s"	, (char *)__FILE__	);
    printf ( "	%s"		, tb->Name		);
    printf ( "\n" );
    //printf ( "Col=~%c~	Row=0x%02X\n", TB->Col, TB->Row	);
    //printf ( "SQL=~%s~\n"		, tb->SQLQuery		);
#endif

    if ( strcmp ( tb->SQLQuery, "select name from systables" ) == 0 ) {
	sprintf ( plCMD, "\
	    @sTbl = $hDb->func ( 'list_tables' );\
	    $tbRecords = $#sTbl;\
	" );
	eval_pv ( plCMD, FALSE  );
	CMD_STD_OUT ( plCMD );
    //amount of Records
	tb->Records	= SvIV ( get_sv ( "tbRecords", 0 ) ) + 1;
    //amount of Fields
	tb->Fields	= 1;
    //all OK
	tb->Result	= tb;
	return Error;
    }//if ( strcmp ( tb->SQLQuery, "select name from systables" ) == 0 )

    sprintf ( plCMD, "\
    $hSt = $hDb->prepare( \"select * from %s\" );\
    $hSt->execute();\
    ", tb->Name );// 2do handle 4 every tabel -> multiple tbOpen ...
    eval_pv ( plCMD, FALSE );
    CMD_STD_OUT ( plCMD );

    sprintf ( plCMD, "\
    $tbRecords=$hSt->rows;\
    $coRecords=$hSt->{NUM_OF_FIELDS};\
    $raResAll = $hSt->fetchall_arrayref;\
    " );
    eval_pv ( plCMD, FALSE  );
    CMD_STD_OUT ( plCMD );

//amount of Records
    tb->Records	= SvIV ( get_sv ( "tbRecords", 0 ) );
//amount of Fields
    tb->Fields  = SvIV ( get_sv ( "coRecords", 0 ) );

//all OK
    tb->Result = tb->db->Conn;	//dummy pointer

    return Error;

}//char	*tbOpen		( _bnTable *tb )


_bnColumn	*tbColumnInsert	( _bnTable *tb ) {
PFLID

char *Error = tb->Error;

char	*myName = new char[20];
    myName[0] = 0;
    if ( tb->Result	== tb )		//select name from systables
	sprintf ( myName, "name" );
    else
#ifdef FIRST_LINE_FIELD_NAME
    {
	sprintf ( plCMD, "$coName=$hSt->{NAME}->[%ld];", tb->ColumnInsertFokus );
	eval_pv ( plCMD, FALSE );
	CMD_STD_OUT ( plCMD );
	char *plName = SvPV_nolen ( get_sv ( "coName", 0 ) );
	if ( ! plName    ) { SET_ERROR ( "! plName"    ); return NULL; }
	strcpy ( myName, plName );
    }
#else
	sprintf ( myName, "A%05ld", tb->ColumnInsertFokus );
#endif

    if ( ! myName[0] ) { SET_ERROR ( "! myName[0]" ); return NULL; }

long	 myType = 100;
long	 mySize = 255;
long	 myFlags = 0;

//Flags Mapping
    //if ( strcmp ( myName, "ID" ) == 0 ) myFlags += bnCO_PRI_KEY;
    //if ( strcmp ( myName, "ID" ) == 0 ) myFlags += bnCO_AUTO_INCREMENT;

    return    coInsertX	( tb, (_DEF2COL *)&ExcelPerl2DEF, myName, myType, mySize, myFlags );

}//_bnColumn	*tbColumnInsert	( _bnTable *tb )


char	*tbClose	( _bnTable *tb ) {
PFLID

//error check
    if ( ! tb		) return NULL;

char *Error = tb->Error;

    if ( Error[0] 	) return Error;
    if ( ! tb->Result	) return Error;	//not open

#ifdef ACTION
    printf ( "%s"	, (char *)__PRETTY_FUNCTION__	);
    printf ( "	%s"	, (char *)__FILE__		);
    printf ( "	%s"	, tb->Name			);
    printf ( "\n" );
#endif

//2do hTB->disconnect ...

//all OK
    tb->Result	= NULL;
    tb->Records	= 0;
    tb->Fields	= 0;
    tb->Error[0]= 0;
    tb->Fokus	= 0;

    return Error;

}//char	*tbClose	( _bnTable *tb )


char	*tbColumn	( _bnTable *tb ) {
PFLID

//error check
    if ( ! tb		) return NULL;

char *Error = tb->Error;

    if ( Error[0] 	) return NULL;
    if ( ! tb->Records	) return NULL;
    if ( ! tb->Result	) SET_ERROR ( "! tb->Result" );
    if ( Error[0]	) return NULL;

//select name from systables
    if ( tb->Result	== tb ) {
	sprintf ( plCMD, "$coData = $sTbl[%ld];", tb->Fokus - 1 );
	eval_pv ( plCMD, FALSE );
	CMD_STD_OUT ( plCMD );
    char *plName = SvPV_nolen ( get_sv ( "coData", 0 ) );
	if ( ! plName    ) { SET_ERROR ( "! plName"    ); return NULL; }
	return plName;
    }//if ( tb->Result	== tb )
//select name from systables done

long loop = 0;
    while ( _bnColumn	*myCol = tb->Columns[loop++] )
	if ( strcmp ( tb->FetchColumn->Name, myCol->Name ) == 0 ) {
	    sprintf ( plCMD, "$coData=@$raRes[%ld];", loop - 1 );
	    eval_pv ( plCMD, FALSE );
	    CMD_STD_OUT ( plCMD );
	char *plName = SvPV_nolen ( get_sv ( "coData", 0 ) );
	    if ( ! plName    ) { SET_ERROR ( "! plName"    ); return NULL; }
	    return plName;
	}

    SET_ERROR2 ( "Column ~%s~ not found", tb->FetchColumn->Name );
    return NULL;

}//char	*tbColumn	( _bnTable *tb )


char	*tbRecord	( _bnTable *tb ) {
PFLID

char *Error = tb->Error;

    if ( tb->Result	== tb ) return Error;

    sprintf ( plCMD, "$raRes = @$raResAll[%ld];", tb->Fokus - 1 );
    eval_pv ( plCMD, FALSE );
    CMD_STD_OUT ( plCMD );

    return Error;

}//char	*tbRecord	( _bnTable *tb )


char	*tbSQLBuild	( _bnTable *tb ) {
PFLID

    switch ( tb->SQLBuildMode ) {
    	case SELECT:{}break;
    	case INSERT:{ sprintf ( tb->Error, "%s @ %s[%ld]\n", "This Modul dont support INSERT", __PRETTY_FUNCTION__, __LINE__ ); }break;
    	case UPDATE:{ sprintf ( tb->Error, "%s @ %s[%ld]\n", "This Modul dont support UPDATE", __PRETTY_FUNCTION__, __LINE__ ); }break;
	case DELETE:{ sprintf ( tb->Error, "%s @ %s[%ld]\n", "This Modul dont support DELETE", __PRETTY_FUNCTION__, __LINE__ ); }break;
    	case SHOW_TABLES:{}break;
    }//switch ( tb->SQLBuildMode )

    return tb->Error;

}//char	*tbSQLBuild	( _bnTable *tb )


char	*coDEF	( _bnColumn *co ) {
PFLID

    //return DEF2COL ( co, (_DEF2COL *)&DEF2ExcelPerl );//2do test it
    return NULL;

}//char	*coDEF	( _bnTable *tb )

}//extern "C"
