#ifndef DEFInformix_h
#define DEFInformix_h

#include <DEF2COL.h>

_DEF2COL Informix2DEF[] = {
    {  "char",   bnCHAR,                 0,                       "char()",  0, 0 },
    {  "long",   bnLONG, sizeof (   long ),                     "smallint",  1, 0 },
    {  "long",   bnLONG, sizeof (   long ),                      "integer",  2, 0 },
    {"double", bnDOUBLE, sizeof ( double ),                 "decimal(x,y)",  5, 0 },
    {  "char",   bnCHAR,                30,                   "money(x,y)",  8, 0 },
    {"serial",   bnLONG, sizeof (   long ),                       "serial",  6, 0 },
    {  "char",   bnCHAR,                30,                         "date",  7, 0 },
    {  "char",   bnCHAR,                30, "datetime year to fraction(3)", 10, 0 },
    {      "",        0,                 0,                             "",  0, 0 }
};
//datetime year to second	= 10


_DEF2COL  DEF2Informix[] = {
    { "serial",   bnLONG, 0, "serial PRIMARY KEY",  0, 0 },
    {   "long",   bnLONG, 0,            "integer",  0, 0 },
    { "double", bnDOUBLE, 0,       "decimal(9,2)",  5, 0 },
    {   "char",   bnCHAR, 0,          "char(%ld)",  0, 0 },
    {      "" ,        0, 0,                   "",  0, 0 }
};

#endif
