#include <stdlib.h>
#include <stdio.h>
#include <executor/spi.h>


char	bufferSQL[4096];

typedef struct {
    long length;
    char data[1];
} text1;

SPITupleTable *tuptable;
HeapTuple tuple;


//prototypes
text1	*ip_hostphysicalid	( long ipID , long ipHostPhysicalID );



/*
char	*SysLog			( char *slString ) {

//handle Error
    if ( strncmp ( slString , "Err" , 3 ) == 0 ) {
    int		counter;
    char	xStr[2];
    char	slSQL[1024];
    char	bSQL[1024];

	lErr++;
	strcpy ( sErr , slString );
	bSQL[0] = 0;
	for ( counter = 0; counter < strlen ( bufferSQL ); counter++ ) {
	    sprintf ( xStr , "%c" , bufferSQL[counter] );
	    if ( strcmp ( xStr, "'"  ) == 0 ) xStr[0] = '_';
	    if ( strcmp ( xStr, "\"" ) == 0 ) xStr[0] = '_';
	    strcat ( bSQL , xStr );
	}

	//Type, Memo, Modul, Date
	sprintf ( slSQL , "insert into \"SysLog\" values ('%s', '%s')", slString, bSQL );
	SPI_exec ( slSQL , 1 );
    }

//handle Error
    if ( strncmp ( slString , "Mes" , 3 ) == 0 ) {
	lMsg++;
	strcpy ( sMsg , slString );
    }

    return slString;

}//char	*SysLog			( char *slString, char *slModul )
*/

text1	*ip_hostphysicalid	( long ipID , long ipHostPhysicalID ) {
char ipHostPhysicalName[100];
char RetMsg[255];
//char xRet[255];
text1 *sRet = (text1 *) malloc( 255 + sizeof (long) );

//open SPI
    if ( SPI_connect () != SPI_OK_CONNECT ) strcpy ( RetMsg , "Error SPI connect !" );
    else {
	sprintf ( RetMsg , "Service %ld %ld ok !", ipID, ipHostPhysicalID );

    //get HostPhysical.Name
	sprintf ( bufferSQL , "SELECT \"Name\" FROM \"HostPhysical\" WHERE \"ID\"=%ld;", ipHostPhysicalID );
	if ( SPI_exec ( bufferSQL , 1 ) != SPI_OK_SELECT ) strcpy ( RetMsg, "Error: SQL#0 StampUpDate" );
	tuptable = SPI_tuptable; tuple = tuptable->vals[0];
	if ( SPI_getvalue( tuple, SPI_tuptable->tupdesc, 1 ) ) {
	    strcpy ( ipHostPhysicalName, SPI_getvalue( tuple, SPI_tuptable->tupdesc, 1 ) );
	}
    //get HostPhysical.Name done

	sprintf ( bufferSQL , "UPDATE \"IP\" SET \"HostPhysicalID\"=%ld, \"HostPhysicalName\"='%s' WHERE ( \"ID\"=%ld );" , ipHostPhysicalID, ipHostPhysicalName, ipID );
	if ( SPI_exec ( bufferSQL , 5 ) != SPI_OK_UPDATE ) strcpy ( RetMsg, "Error: SQL#1 StampUpDate" );

    //check what's 2 do
//	memcpy ( xRet , tBegTxt->data, tBegTxt->length - sizeof (long) );
//	xRet[ tBegTxt->length - sizeof (long) ] = 0;

//#ifdef StampDEBUG
//    sprintf ( bufferSQL , "Error: ID:%ld UserID:%ld Beg:%ld BegTxt:%s End:%ld EndModeID:%ld stampedit", sID, sUserID, sBeg, xRet, sEnd, sEndModeID );
//    SysLog ( bufferSQL );
//#endif

//	if ( sID == 0 )	strcpy ( RetMsg , StampInsert ( sID, dirtyX.constUserID, sBeg , xRet, sEnd, sEndModeID ) );
//	else		strcpy ( RetMsg , StampUpDate ( sID, dirtyX.constUserID, sBeg , xRet, sEnd, sEndModeID ) );

    //close SPI
	SPI_finish ();

    }
//open SPI done


//build return text
//    sprintf ( bufferSQL , "%s;err%03ld;%s;msg%03ld;%s;" , RetMsg, lErr, sErr, lMsg, sMsg );
    sprintf ( bufferSQL , "%s;", RetMsg );
    sRet->length = strlen ( bufferSQL ) + sizeof (long); strcpy ( sRet->data , bufferSQL );
    return (sRet);

}//text1	*ip_hostphysicalid	( long ipID , long ipHostPhysicalID )
