//2do via bnTableHTML Column not found .... @ 194
//#define DEBUG
//#define ACTION
#include <stdio.h>
#include <stdlib.h>

#include "bnMakro.h"
#include "bnSQL.h"
#include "bnFile.h"
#include "bnStrSplit.h"
#include "bnString.h"


class	_TxtResult {
public:
    _bnFile	File;
    _bnStrSplit	Rec;
};


extern "C" {

char 	*Txt1_0_dbOpen ( _bnDataBase *db ) {
#ifdef DEBUG
    printf ( "%70s\t[%04ld]\n", __PRETTY_FUNCTION__, __LINE__ );
#endif

//error check
    if ( db->Error[0] ) return db->Error;

#ifdef ACTION
	printf ( "%s"		, (char *)__PRETTY_FUNCTION__ );
	printf ( "	%s"	, (char *)__FILE__ );
	printf ( "	%s"	, db->Base );
	printf ( "@%s"		, db->Host );
	printf ( "\n" );
#endif

    db->Error[0]	= 0;
    return db->Error;

}//char 	*dbOpen ( _bnDataBase *db )


char	*Txt1_0_dbClose ( _bnDataBase *db ) {
#ifdef DEBUG
    printf ( "%70s\t[%04ld]\n", __PRETTY_FUNCTION__, __LINE__ );
#endif

#ifdef ACTION
	printf ( "%s"		, (char *)__PRETTY_FUNCTION__ );
	printf ( "	%s"	, (char *)__FILE__ );
	printf ( "	%s"	, db->Base );
	printf ( "@%s"		, db->Host );
	printf ( "\n" );
#endif

    return db->Error;

}//char	*dbClose ( _bnDataBase *db )


char	*Txt1_0_tbOpen		( _bnTable *tb ) {
#ifdef DEBUG
    printf ( "%70s\t[%04ld]\n", __PRETTY_FUNCTION__, __LINE__ );
#endif

//error check
    if ( tb->Error[0]		) return tb->Error;
    if ( tb->Result		) return tb->Error;

//Options
    if ( ! tb->db->Options		 ) {
	tb->db->Options = (char *)malloc ( 5 );//2do free
	if ( ! tb->db->Options ) sprintf ( tb->Error, "%s @ %s[%d]", "! tb->db->Options", __PRETTY_FUNCTION__, __LINE__ );
	if ( tb->Error[0] ) return tb->Error;
	tb->db->Options[0] = '|';
	tb->db->Options[1] = 0x0A;
	tb->db->Options[2] =   0;
    }
    if ( tb->Error[0]		) return tb->Error;

#ifdef ACTION
	printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
	printf ( "		%s"	, (char *)__FILE__	);
	printf ( "	%s"		, tb->Name		);
	printf ( "\n" );
	//printf ( "Col=~%c~	Row=0x%02X\n", TB->Col, TB->Row	);
	//printf ( "SQL=~%s~\n"		, tb->SQLQuery		);
#endif

_TxtResult	*myResult = new _TxtResult;
    if ( ! myResult   ) sprintf ( tb->Error, "%s @ %s[%d]", "! myResult", __PRETTY_FUNCTION__, __LINE__ );
    if ( tb->Error[0] ) return tb->Error;

    sprintf ( myResult->File.Name, "%s/%s", tb->db->Base, tb->Name	);
    strcpy  ( myResult->File.Flag, "rt"					);
	      myResult->File.Row = tb->db->Options[1];
	      myResult->File.Open ();
    if (      myResult->File.Error[0] ) sprintf ( tb->Error, "%s @ %s[%d]", myResult->File.Error, __PRETTY_FUNCTION__, __LINE__ );
    if ( tb->Error[0] ) return tb->Error;

//amount of Records
    while ( ! myResult->File.Next ()[0] )	tb->Records++;
    fseek ( myResult->File.Stream, 0, SEEK_SET );

//amount of Fields
_bnStrSplit	sSplit;
    myResult->File.Next ();
    sSplit.In = (char *)&myResult->File.Line;
    sSplit.sCol = tb->db->Options[0];	//seperator Column
    sSplit.Open ();
    tb->Fields  = sSplit.Records;
    fseek ( myResult->File.Stream, 0, SEEK_SET );

//all OK
    tb->Result = ( _TxtResult *)myResult;

    return tb->Error;

}//char	*tbOpen		( _bnTable *tb )


_bnColumn	*Txt1_0_tbColumnInsert	( _bnTable *tb ) {
PFLID

_bnColumn    *Dummy = new _bnColumn;
	      Dummy->Name	= (char *)malloc ( 20 );
    sprintf ( Dummy->Name	, "Char%03ld", tb->ColumnInsertFokus + 1 );
	      Dummy->Type	= (char *)"char";
	      Dummy->Size	= 255;
	      Dummy->Flags	= 0;
    return    Dummy;

}//_bnColumn	*tbColumnInsert	( _bnTable *tb )


char	*Txt1_0_tbClose	( _bnTable *tb ) {
#ifdef DEBUG
    printf ( "%70s\t[%04ld]\n", __PRETTY_FUNCTION__, __LINE__ );
#endif

//Table is closed
    if ( ! tb->Result ) return tb->Error;

#ifdef ACTION
    printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
    printf ( "	%s"	, (char *)__FILE__		);
    printf ( "	%s"	, tb->Name			);
    printf ( "\n" );
#endif

_TxtResult  *myResult = (_TxtResult *)tb->Result;
	     myResult->Rec.Close ();
	     myResult->File.Close ();
    if (     myResult->File.Error[0] ) sprintf ( tb->Error, "%s @ %s[%d]", myResult->File.Error, __PRETTY_FUNCTION__, __LINE__ );
    if ( tb->Error[0] ) return tb->Error;

//all OK
    delete myResult;
    tb->Result	= NULL;
    tb->Records	= 0;
    tb->Fields	= 0;
    tb->Error[0]= 0;
    tb->Fokus	= 0;

    return tb->Error;

}//char	*tbClose	( _bnTable *tb )


char	*Txt1_0_tbColumn	( _bnTable *tb ) {
#ifdef DEBUG
    printf ( "%70s\t[%04ld]\n", __PRETTY_FUNCTION__, __LINE__ );
#endif

//error check
    if ( ! tb->Records	) return NULL;
    if ( ! tb->Result	) sprintf ( tb->Error, "%s @ %s[%d]\n", "! tb->Result", __PRETTY_FUNCTION__, __LINE__ );
    if ( tb->Error[0]	) return NULL;

_TxtResult *myResult = (_TxtResult *)tb->Result;

long loop = 0;
    while ( _bnColumn	*myCol = tb->Columns[loop++] ) {
	if ( myResult->Rec.Records < loop ) break;
	if ( strcmp ( tb->FetchColumn->Name, myCol->Name ) == 0 )
	    return myResult->Rec.Data[loop - 1];
    }

    sprintf ( tb->Error, "%s @ %s[%d]\n", "Column not found", __PRETTY_FUNCTION__, __LINE__ );
    return NULL;

}//char	*tbColumn	( _bnTable *tb )


char	*Txt1_0_tbRecord	( _bnTable *tb ) {
#ifdef DEBUG
    printf ( "%70s\t[%04ld]\n", __PRETTY_FUNCTION__, __LINE__ );
#endif

//error check
    if ( ! tb->Records	) return NULL;
    if ( ! tb->Result	) sprintf ( tb->Error, "%s @ %s[%d]\n", "! tb->Result", __PRETTY_FUNCTION__, __LINE__ );
    if ( tb->Error[0]	) return NULL;

_TxtResult *myResult = (_TxtResult *)tb->Result;

    //2do seek set
    myResult->File.Next ();

    StrDrop		( myResult->File.Line, tb->db->Options[1] );//2do ???

//split xFile.Line
    myResult->Rec.Close ();
    myResult->Rec.In = (char *)&myResult->File.Line;
    myResult->Rec.sCol = tb->db->Options[0];		//seperator Column
    myResult->Rec.Open ();

    return tb->Error;

}//char	*tbRecord	( _bnTable *tb )


char	*Txt1_0_tbSQLBuild	( _bnTable *tb ) {
#ifdef DEBUG
    printf ( "%70s\t[%04ld]\n", __PRETTY_FUNCTION__, __LINE__ );
#endif
    switch ( tb->SQLBuildMode ) {
    	case SELECT:{}break;
    	case INSERT:{ sprintf ( tb->Error, "%s @ %s[%d]\n", "This Modul dont support INSERT", __PRETTY_FUNCTION__, __LINE__ ); }break;
    	case UPDATE:{ sprintf ( tb->Error, "%s @ %s[%d]\n", "This Modul dont support UPDATE", __PRETTY_FUNCTION__, __LINE__ ); }break;
	case DELETE:{ sprintf ( tb->Error, "%s @ %s[%d]\n", "This Modul dont support DELETE", __PRETTY_FUNCTION__, __LINE__ ); }break;
	case SHOW_TABLES:{ sprintf ( tb->Error, "%s @ %s[%d]\n", "This Modul dont support SHOW_TABLES", __PRETTY_FUNCTION__, __LINE__ ); }break;
    }//switch ( tb->SQLBuildMode )

    return tb->Error;

}//char	*tbSQLBuild	( _bnTable *tb )


char	*Txt1_0_coDEF	( _bnColumn *co ) {
#ifdef DEBUG
    printf ( "%70s\t[%04ld]\n", __PRETTY_FUNCTION__, __LINE__ );
#endif

    //return DEF2COL ( co, (_DEF2COL *)&DEF2Postgres );//2do
    return NULL;

}//char	*coDEF	( _bnTable *tb )

}//extern "C"
