//Copyright 2017-2018 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
//#define mssql_BUILTIN

#ifdef mssql_BUILTIN
char *mssql_dbOpen          ( void * );
char *mssql_dbClose         ( void * );
char *mssql_tbOpen          ( void * );
char *mssql_tbColumnInsert  ( void *, _bncColumn *co, unsigned long );
char *mssql_tbClose         ( void * );
char *mssql_tbRecord        ( void * );
char *mssql_tbColumn        ( void *, const char *, unsigned char **, unsigned long * );
char *mssql_tbSQLBuild      ( void * );
char *mssql_coDEF           ( void * );
# define mssql_BUILTIN_DRIVER { \
    if ( strcmp ( Driver, "mssql" ) == 0 ) { \
	if (                 mssql_dbOpen ) { \
	    dbOpen         = mssql_dbOpen        ; \
	    dbClose        = mssql_dbClose       ; \
	    tbOpen         = mssql_tbOpen        ; \
	    tbColumnInsert = mssql_tbColumnInsert; \
	    tbClose        = mssql_tbClose       ; \
	    tbRecord       = mssql_tbRecord      ; \
	    tbColumn       = mssql_tbColumn      ; \
	    tbSQLBuild     = mssql_tbSQLBuild    ; \
	    coDEF          = mssql_coDEF         ; \
	    return Error; \
	} \
    } \
}
# define mssql_BUILTIN_HAVE "mssql;"
#else
# define mssql_BUILTIN_DRIVER
# define mssql_BUILTIN_HAVE
#endif
