#ifndef DEFPostgres_h
#define DEFPostgres_h

#include "DEF2COL.h"

_DEF2COL Postgres2DEF[] = {
	"char"	,   bnCHAR,               255,                          "2do", 1042, 0 ,//2do size
	"char"	,   bnCHAR,               255,                          "2do", 1043, 0 ,//2do size
	"char"	,   bnCHAR,                 0,                          "2do",   19, 0 ,
	"double", bnDOUBLE, sizeof ( double ),                          "2do",  701, 0 ,
	"long"	,   bnLONG, sizeof (   long ),                          "2do",   23, 0 ,
	"long"	,   bnLONG, sizeof (   long ),                          "2do",   20, 0 ,
	"long"	,   bnLONG, sizeof (   long ),                          "oid",   26, 0 ,//2do rename 2 serial
	""	, 	 0,                 0,                             "",    0, 0 
    };

_DEF2COL DEF2Postgres[] = {
    "serial"	,   bnLONG, 0, "serial PRIMARY KEY", 0, 0 ,
    "long"	,   bnLONG, 0,               "int4", 0, 0 ,
    "double"	, bnDOUBLE, 0,             "float8", 0, 0 ,
    "char"	,   bnCHAR, 0,       "varchar(%ld)", 0, 0 ,
    ""		, 	 0, 0,                   "", 0, 0
};

#endif
